/[gentoo-x86]/eclass/qt4.eclass
Gentoo

Diff of /eclass/qt4.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.22 Revision 1.30
1# Copyright 2005 Gentoo Foundation 1# Copyright 2005 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/qt4.eclass,v 1.22 2007/08/02 11:22:40 caleb Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/qt4.eclass,v 1.30 2007/12/19 18:07:47 caleb Exp $
4# 4
5# @ECLASS: qt4.eclass
6# @MAINTAINER:
5# Author Caleb Tennis <caleb@gentoo.org> 7# Caleb Tennis <caleb@gentoo.org>
6# 8# @BLURB:
7# This eclass is simple. Inherit it, and in your depend, do something like this: 9# Eclass for Qt4 packages
8# 10# @DESCRIPTION:
9# DEPEND="$(qt4_min_version 4)" 11# This eclass contains various functions that may be useful
10# 12# when dealing with packages using Qt4 libraries.
11# and it handles the rest for you 13
12#
13# 08.16.06 - Renamed qt_min_* to qt4_min_* to avoid conflicts with the qt3 eclass. 14# 08.16.06 - Renamed qt_min_* to qt4_min_* to avoid conflicts with the qt3 eclass.
14# - Caleb Tennis <caleb@gentoo.org> 15# - Caleb Tennis <caleb@gentoo.org>
15 16
16inherit eutils multilib toolchain-funcs versionator 17inherit eutils multilib toolchain-funcs versionator
17 18
18IUSE="${IUSE}" 19QTPKG="x11-libs/qt-"
20QT4MAJORVERSIONS="4.4 4.3 4.2 4.1 4.0"
21QT4VERSIONS="4.4.0_rc1 4.3.3 4.3.2-r1 4.3.2 4.3.1-r1 4.3.1 4.3.0-r2 4.3.0-r1 4.3.0 4.3.0_rc1 4.3.0_beta1 4.2.3-r1 4.2.3 4.2.2 4.2.1 4.2.0-r2 4.2.0-r1 4.2.0 4.1.4-r2 4.1.4-r1 4.1.4 4.1.3 4.1.2 4.1.1 4.1.0 4.0.1 4.0.0"
19 22
20QTPKG="x11-libs/qt-" 23# @FUNCTION: qt4_min_version
21QT4MAJORVERSIONS="4.3 4.2 4.1 4.0" 24# @USAGE: [minimum version]
22QT4VERSIONS="4.3.0 4.3.0_rc1 4.3.0_beta1 4.2.3-r1 4.2.3 4.2.2 4.2.1 4.2.0-r2 4.2.0-r1 4.2.0 4.1.4-r2 4.1.4-r1 4.1.4 4.1.3 4.1.2 4.1.1 4.1.0 4.0.1 4.0.0" 25# @DESCRIPTION:
23 26# This function should be called in package DEPENDs whenever it depends on qt4.
27# Simple example - in your depend, do something like this:
28# DEPEND="$(qt4_min_version 4.2)"
29# if package can be build with qt-4.2 or higher.
24qt4_min_version() { 30qt4_min_version() {
25 echo "|| (" 31 echo "|| ("
26 qt4_min_version_list "$@" 32 qt4_min_version_list "$@"
27 echo ")" 33 echo ")"
28} 34}
31 local MINVER="$1" 37 local MINVER="$1"
32 local VERSIONS="" 38 local VERSIONS=""
33 39
34 case "${MINVER}" in 40 case "${MINVER}" in
35 4|4.0|4.0.0) VERSIONS="=${QTPKG}4*";; 41 4|4.0|4.0.0) VERSIONS="=${QTPKG}4*";;
36 4.1|4.1.0|4.2|4.2.0) 42 4.1|4.1.0|4.2|4.2.0|4.3|4.3.0|4.4|4.4.0)
37 for x in ${QT4MAJORVERSIONS}; do 43 for x in ${QT4MAJORVERSIONS}; do
38 if $(version_is_at_least "${MINVER}" "${x}"); then 44 if $(version_is_at_least "${MINVER}" "${x}"); then
39 VERSIONS="${VERSIONS} =${QTPKG}${x}*" 45 VERSIONS="${VERSIONS} =${QTPKG}${x}*"
40 fi 46 fi
41 done 47 done
51 esac 57 esac
52 58
53 echo "${VERSIONS}" 59 echo "${VERSIONS}"
54} 60}
55 61
62# @FUNCTION: qt4_pkg_setup
63# @MAINTAINER:
64# Caleb Tennis <caleb@gentoo.org>
65# Przemyslaw Maciag <troll@gentoo.org>
66# @DESCRIPTION:
67# Default pkg_setup function for packages that depends on qt4. If you have to
68# create ebuilds own pkg_setup in your ebuild, call qt4_pkg_setup in it.
69# This function uses two global vars from ebuild:
70# - QT4_BUILT_WITH_USE_CHECK - contains use flags that need to be turned on for
71# =x11-libs/qt-4*
72# - QT4_OPTIONAL_BUILT_WITH_USE_CHECK - qt4 flags that provides some
73# functionality, but can alternatively be disabled in ${CATEGORY}/${PN}
74# (so qt4 don't have to be recompiled)
56qt4_pkg_setup() { 75qt4_pkg_setup() {
76 local requiredflags=""
57 for x in ${QT4_BUILT_WITH_USE_CHECK}; do 77 for x in ${QT4_BUILT_WITH_USE_CHECK}; do
58 if ! built_with_use =x11-libs/qt-4* $x; then 78 if ! built_with_use =x11-libs/qt-4* ${x}; then
59 die "This package requires Qt4 to be built with the '${x}' use flag." 79 requiredflags="${requiredflags} ${x}"
60 fi 80 fi
61 done 81 done
82
83 local optionalflags=""
84 for x in ${QT4_OPTIONAL_BUILT_WITH_USE_CHECK}; do
85 if use ${x} && ! built_with_use =x11-libs/qt-4* ${x}; then
86 optionalflags="${optionalflags} ${x}"
87 fi
88 done
89
90 local diemessage=""
91 if [[ ${requiredflags} != "" ]]; then
92 eerror
93 eerror "(1) In order to compile ${CATEGORY}/${PN} first you need to build"
94 eerror "=x11-libs/qt-4* with USE=\"${requiredflags}\" flag(s)"
95 eerror
96 diemessage="(1) recompile qt4 with \"${requiredflags}\" USE flag(s) ; "
97 fi
98 if [[ ${optionalflags} != "" ]]; then
99 eerror
100 eerror "(2) You are trying to compile ${CATEGORY}/${PN} package with"
101 eerror "USE=\"${optionalflags}\""
102 eerror "while qt4 is built without this particular flag(s): it will"
103 eerror "not work."
104 eerror
105 eerror "Possible solutions to this problem are:"
106 eerror "a) install package ${CATEGORY}/${PN} without \"${optionalflags}\" USE flag(s)"
107 eerror "b) re-emerge qt4 with \"${optionalflags}\" USE flag(s)"
108 eerror
109 diemessage="${diemessage}(2) recompile qt4 with \"${optionalflags}\" USE flag(s) or disable them for ${PN} package\n"
110 fi
111
112 [[ ${diemessage} != "" ]] && die "can't emerge ${CATEGORY}/${PN}: ${diemessage}"
62} 113}
63 114
115# @FUNCTION: eqmake4
116# @USAGE: [.pro file] [additional parameters to qmake]
117# @MAINTAINER:
118# Przemyslaw Maciag <troll@gentoo.org>
119# Davide Pesavento <davidepesa@gmail.com>
120# @DESCRIPTION:
121# Runs qmake on the specified .pro file (defaults to
122# ${PN}.pro if eqmake4 was called with no argument).
123# Additional parameters are passed unmodified to qmake.
64eqmake4() { 124eqmake4() {
65 local LOGFILE="${T}/qmake-$$.out" 125 local LOGFILE="${T}/qmake-$$.out"
66 local projprofile="${1}" 126 local projprofile="${1}"
67 [ -z ${projprofile} ] && projprofile="${PN}.pro" 127 [[ -z ${projprofile} ]] && projprofile="${PN}.pro"
68 shift 1 128 shift 1
69 129
70 ebegin "Processing qmake ${projprofile}" 130 ebegin "Processing qmake ${projprofile}"
71 131
72 # file exists? 132 # file exists?
73 if [ ! -f ${projprofile} ]; then 133 if [[ ! -f ${projprofile} ]]; then
74 echo 134 echo
75 eerror "Project .pro file \"${projprofile}\" does not exists" 135 eerror "Project .pro file \"${projprofile}\" does not exists"
76 eerror "qmake cannot handle non-existing .pro files" 136 eerror "qmake cannot handle non-existing .pro files"
77 echo 137 echo
78 eerror "This shouldn't happen - please send a bug report to bugs.gentoo.org" 138 eerror "This shouldn't happen - please send a bug report to bugs.gentoo.org"
84 echo "****** qmake ${projprofile} ******" >> ${LOGFILE} 144 echo "****** qmake ${projprofile} ******" >> ${LOGFILE}
85 echo >> ${LOGFILE} 145 echo >> ${LOGFILE}
86 146
87 # as a workaround for broken qmake, put everything into file 147 # as a workaround for broken qmake, put everything into file
88 if has debug ${IUSE} && use debug; then 148 if has debug ${IUSE} && use debug; then
89 echo -e "$CONFIG -= release\nCONFIG += no_fixpath debug" >> ${projprofile} 149 echo -e "\nCONFIG -= release\nCONFIG += no_fixpath debug" >> ${projprofile}
90 else 150 else
91 echo -e "$CONFIG -= debug\nCONFIG += no_fixpath release" >> ${projprofile} 151 echo -e "\nCONFIG -= debug\nCONFIG += no_fixpath release" >> ${projprofile}
92 fi 152 fi
93 153
94 /usr/bin/qmake ${projprofile} \ 154 /usr/bin/qmake ${projprofile} \
95 QTDIR=/usr/$(get_libdir) \ 155 QTDIR=/usr/$(get_libdir) \
96 QMAKE=/usr/bin/qmake \ 156 QMAKE=/usr/bin/qmake \
108 168
109 local result=$? 169 local result=$?
110 eend ${result} 170 eend ${result}
111 171
112 # was qmake successful? 172 # was qmake successful?
113 if [ ${result} -ne 0 ]; then 173 if [[ ${result} -ne 0 ]]; then
114 echo 174 echo
115 eerror "Running qmake on \"${projprofile}\" has failed" 175 eerror "Running qmake on \"${projprofile}\" has failed"
116 echo 176 echo
117 eerror "This shouldn't happen - please send a bug report to bugs.gentoo.org" 177 eerror "This shouldn't happen - please send a bug report to bugs.gentoo.org"
118 echo 178 echo

Legend:
Removed from v.1.22  
changed lines
  Added in v.1.30

  ViewVC Help
Powered by ViewVC 1.1.20